#include <algorithm>
#include <vector>
#include <cmath>
#include <cstdlib>
#include <cstdio>

int main(int argc, char *argv[]) {

	long long min = atol(argv[1]), max = atol(argv[2]); long num = atol(argv[3]), tid = atol(argv[4]), rnd = atol(argv[5]); srand(rnd);
	std::vector<long long> X(num + 2), Y(num + 2);
	long long len = max - min, mid = (min + max) / 2; long i0 = num / 2, i1 = num, i2 = num + 1;
	//Все точки лежат на прямоугольнике:
	double h = len / (num / 2);
	for (long k = i0; k < num; ++ k) { X[k] = (rand() % 2)? (min): (max); Y[k] = min + h * (k - i0); }
	for (long k = 0; k < i0; ++ k) { X[k] = min + h * k; Y[k] = (rand() % 2)? (min): (max); }
	switch (tid) {
	case 1: X[i1] = min; Y[i1] = min; X[i2] = max; Y[i2] = min; break;
	case 2: X[i1] = min; Y[i1] = min; X[i2] = min; Y[i2] = max; break;
	case 3: X[i1] = min; Y[i1] = max; X[i2] = max; Y[i2] = max; break;
	case 4: X[i1] = max; Y[i1] = min; X[i2] = max; Y[i2] = max; break;
	case 5: X[i1] = min; Y[i1] = min; X[i2] = max; Y[i2] = max; break;
	case 6: X[i1] = min; Y[i1] = max; X[i2] = max; Y[i2] = min; break;
	}
	//...
	std::vector<long> IND(num); for (long i = 0; i < num; ++ i) IND[i] = i;
	std::random_shuffle(IND.begin(), IND.end());
	//...
	FILE *fid = fopen("input.txt", "wt"); fprintf(fid, "%lu\n", num);
	for (long i = 0; i < num; ++ i) {
		fprintf(fid, "%lli\t", X[IND[i]]);
		fprintf(fid, "%lli\n", Y[IND[i]]);
	}
	fprintf(fid, "%lli\t", X[i1]);
	fprintf(fid, "%lli\n", Y[i1]);
	fprintf(fid, "%lli\t", X[i2]);
	fprintf(fid, "%lli\n", Y[i2]);
	fclose(fid);

	return 0;
}
