#include <algorithm>
#include <vector>
#include <cmath>
#include <cstdlib>
#include <cstdio>

int main(int argc, char *argv[]) {

	long long min = atol(argv[1]), max = atol(argv[2]), len = max - min, mid = (min + max) / 2;
	//...
	long long x1 = atol(argv[3]), y1 = atol(argv[4]), x2 = atol(argv[5]), y2 = atol(argv[6]), x3 = atol(argv[7]), y3 = atol(argv[8]);
	//...
	long num = atol(argv[9]), rnd = atol(argv[10]); srand(rnd); std::vector<long long> X(num + 2), Y(num + 2);
	//...
	long j1 = num - 1, j2 = num - 2, j3 = num - 3, j4 = num - 4, i1 = num, i2 = num + 1, i3 = 0;
	//...
	long nk = num - 4, nl = sqrt(nk); double hx = (x2 - x1) / nl, hy = (y2 - y1) / nl;
	long i, k, l, m;
	//...
	//Точки расположены внутри заданного треугольника:
	if (!rnd) {
		for (k = 0, l = 0; (l < nl) && (k < nk); ++ l) {
			long long x0 = x1 + l * hx;
			long long y0 = y1 + l * hy;
			double hx0 = (double) (x3 - x0) / nl, hy0 = (double) (y3 - y0) / nl;
			for (m = 0; (m < nl) && (k < nk); ++ m, ++ k) {
				X[k] = x0 + m * hx0;
				Y[k] = y0 + m * hy0;
			}
		}
		for (; k < nk; ++ k) { l = rand() % k; X[k] = X[l]; Y[k] = Y[l]; }
		X[j4] = min; Y[j4] = min;
		X[j3] = min; Y[j3] = max;
		X[j2] = max; Y[j2] = min;
		X[j1] = max; Y[j1] = max;
	}
	//Случайное распределение точек:
	else {
		for (k = 0; k < num; ++ k) {
			X[k] = min + rand() % len; Y[k] = min + rand() % len;
		}
	}
	X[i3] = x3; Y[i3] = y3;
	X[i2] = x2; Y[i2] = y2;
	X[i1] = x1; Y[i1] = y1;
	//...
	std::vector<long> IND(num); for (i = 0; i < num; ++ i) IND[i] = i;
	std::random_shuffle(IND.begin(), IND.end());
	//...
	FILE *fid = fopen("input.txt", "wt"); fprintf(fid, "%lu\n", num);
	for (i = 0; i < num; ++ i) {
		fprintf(fid, "%lli\t", X[IND[i]]);
		fprintf(fid, "%lli\n", Y[IND[i]]);
	}
	fprintf(fid, "%lli\t", X[i1]);
	fprintf(fid, "%lli\n", Y[i1]);
	fprintf(fid, "%lli\t", X[i2]);
	fprintf(fid, "%lli\n", Y[i2]);
	fclose(fid);

	return 0;
}
